pub use self::{error::Error, verifier::Verifier};
use {
    crate::prelude::{CertificateStore, Request, Response},
    std::io::{Read, Write},
};

mod error;
mod verifier;

#[derive(Debug)]
/// Sends a piece of mail from the sending server to the receiving server
pub struct Sender<S, C, T>
where
    S: CertificateStore,
    C: Sized,
    T: Read + Write + Sized,
{
    /// The full message text to be sent
    pub request: Request,
    /// Verifies the receiving server's certificate
    pub verifier: Verifier<S>,
    /// The TLS stream used for the connection
    pub stream: rustls::StreamOwned<C, T>,
}

impl<S, C, T> Sender<S, C, T>
where
    S: CertificateStore,
    C: Sized,
    T: Read + Write + Sized,
{
    pub fn new(request_str: &str, store: S) -> Result<Self, Error> {
        let request: Request = request_str.parse()?;
        let verifier = Verifier::new(store);
        unimplemented!();
    }

    pub fn send(&mut self) -> Result<Response, Error> {
        unimplemented!();
    }
}
